﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Web;
using System.Drawing;

namespace ImCompareAPP
{
    public class CommonUntil
    {

        public List<int>[] ReturnComparisonResult(List<int> listOne,List<int> listTwo)
        {
            if (listOne == null | listTwo == null) throw new Exception("操作集合出现错误！！！");

            List<int> existList = new List<int>();  //左边的记录在右边通过比对，存在的
            List<int> nonExistList = new List<int>();  //左边的记录在右边通过比对，不存在的

            List<int>[] list = new List<int>[2];

            listOne.Sort();
            listTwo.Sort();

            int countOne = listOne.Count;
            int countTwo = listTwo.Count;
            int temoPos = 0;
            int count = 0;

            for (int i = 0; i < countOne; i++)
            {
                for (int j = temoPos; j < countTwo; j++)
                {
                    count++;
                    if (listOne[i] == listTwo[j])
                    {
                        existList.Add(listOne[i]); // add the id exists in right side
                        temoPos = j;
                        break;
                    }
                }
            }

            for (int m = 0; m < listOne.Count;m++ )
            {
                if (!existList.Contains(listOne[m]))
                {
                    nonExistList.Add(listOne[m]);
                }
            }
            
            list[0] = existList;
            list[1] = nonExistList;

            return  list;
        }

        public StringBuilder ExcelExport(ListView listview)
        {
            #region 头部部分
            StringBuilder sbHeaderStart = new StringBuilder();
            sbHeaderStart.Append("<?xml version=\"1.0\"?>");
            sbHeaderStart.Append("\r\n");
            sbHeaderStart.Append("<ss:Workbook xmlns:ss=\"urn:schemas-microsoft-com:office:spreadsheet\">");
            sbHeaderStart.Append("\r\n");

            StringBuilder sbHeaderEnd = new StringBuilder();
            sbHeaderEnd.Append("\r\n");
            sbHeaderEnd.Append("</ss:Workbook>");
            #endregion

            #region Style样式部分
            StringBuilder sbStyle = new StringBuilder(); 

            StringBuilder sbStyleLeft = new StringBuilder();
            sbStyleLeft.Append("<ss:Styles>");
            sbStyleLeft.Append("<ss:Style ss:ID=\"leftStyle\">");
            sbStyleLeft.Append("<ss:Interior ss:Color=\""+ReturnHEXColor(Color.Wheat)+"\" ss:Pattern=\"Solid\"/>");
            sbStyleLeft.Append("</ss:Style>");

            StringBuilder sbStyleRight = new StringBuilder();
            sbStyleRight.Append("<ss:Style ss:ID=\"rightStyle\">");
            sbStyleRight.Append("<ss:Interior ss:Color=\""+ReturnHEXColor(Color.YellowGreen)+"\" ss:Pattern=\"Solid\"/>");
            sbStyleRight.Append("</ss:Style>");
            sbStyleRight.Append("</ss:Styles>");

            sbStyle.Append(sbStyleLeft.ToString());
            sbStyle.Append(sbStyleRight.ToString());
            #endregion

            #region WorkSheet部分
            StringBuilder sbSheetStart = new StringBuilder();
            sbSheetStart.Append("<ss:Worksheet ss:Name=\"Sheet1\">");
            sbSheetStart.Append("\r\n");

            StringBuilder sbSheetEnd = new StringBuilder();
            sbSheetEnd.Append("\r\n");
            sbSheetEnd.Append("</ss:Worksheet>");
            #endregion

            #region Table部分
            StringBuilder sbTableStart = new StringBuilder();
            sbTableStart.Append("<ss:Table>");
            sbTableStart.Append("\r\n");

            StringBuilder sbTableEnd = new StringBuilder();
            sbTableEnd.Append("\r\n");
            sbTableEnd.Append("</ss:Table>");
            #endregion

            #region Row部分

            StringBuilder sbBody = new StringBuilder();
            foreach (ListViewItem lvi in listview.Items)
            {
                sbBody.Append("<ss:Row>");
                sbBody.Append("\r\n");
                int countSub=lvi.SubItems.Count;
                for (int m = 0; m < countSub; m++)
                {
                    string value=lvi.SubItems[m].Text;

                    //根据背景色判断，然后自动附加Style
                    if (lvi.BackColor == Color.Wheat) 
                    {
                        sbBody.Append("<ss:Cell ss:StyleID=\"leftStyle\">");
                        
                    }
                    else if (lvi.BackColor == Color.YellowGreen)
                    {
                        sbBody.Append("<ss:Cell ss:StyleID=\"rightStyle\">");
                    }
                    else
                    {
                        sbBody.Append("<ss:Cell>");
                    }

                    sbBody.Append("\r\n");
                    sbBody.Append("<ss:Data ss:Type=\"String\">");
                    sbBody.Append(value);
                    sbBody.Append("</ss:Data>");
                    sbBody.Append("\r\n");
                    sbBody.Append("</ss:Cell>");
                    sbBody.Append("\r\n");
                }
                sbBody.Append("</ss:Row>");
                sbBody.Append("\r\n");
                
            }
            #endregion

            StringBuilder sbAll = new StringBuilder();
            sbAll.Append(sbHeaderStart.ToString());
            sbAll.Append(sbStyle.ToString());
            sbAll.Append(sbSheetStart.ToString());
            sbAll.Append(sbTableStart.ToString());
            sbAll.Append(sbBody.ToString());
            sbAll.Append(sbTableEnd.ToString());
            sbAll.Append(sbSheetEnd.ToString());
            sbAll.Append(sbHeaderEnd.ToString());
           
            return sbAll;
        }

        public string ReturnHEXColor(Color color)
        {
            string _colorDecimalism = string.Empty;

            _colorDecimalism = color.R.ToString("X") + color.G.ToString("X") + color.B.ToString("X");

            string result = "#" + _colorDecimalism;
            return result;
        }

        public bool IsNumValidation(string str)
        {
            if (String.IsNullOrEmpty(str)) throw new Exception("待验证的字串不能为空！");

            long result;
            if (Int64.TryParse(str,out result))
            {
                return true;
            }
            return false;
        }

        public string ReturnNewFileName(string originalFileName, string pattern)
        {
            if (String.IsNullOrEmpty(originalFileName)) throw new Exception("文件路径不存在，请检查！！！");
            if (String.IsNullOrEmpty(pattern)) throw new Exception("请输入文件名称！！！");
            if (!originalFileName.Contains("\\")) throw new Exception("文件路径不合法！！！");

            string filePath = originalFileName.Substring(0, originalFileName.LastIndexOf("\\") + 1);
            string newFileName = filePath + pattern ;
            return newFileName;
        }
    }
}
