﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Collections;
using System.Threading;

namespace ImCompareAPP
{
    public partial class mainFrm : Form
    {
        public mainFrm()
        {
            InitializeComponent();
            
            SetStyle(ControlStyles.UserPaint | ControlStyles.OptimizedDoubleBuffer, true);
        }

        private static string[] ColumnHeaderCollection;
        private delegate void DealDataInformationDelegateAsync(ListView listview,string fileName,EnumX enums);  //Loading & Dealing the records, it will need a long time, using async operation
        private delegate void ColorTheResultDelegateAsync(EnumX enums, ListView listview);//Color the records, it will need a long time, using async operation
        private delegate void ExportDataToExcelDelegateAsync(SaveFileDialog saveFileDlg, EnumX enumx, EnumExport export, string filename); //Export to excel, it will need a long time, using async operation

        public static EnumX enumThis;
        public static List<int>[] listPartOne = new List<int>[2];
        public static List<int>[] listPartTwo = new List<int>[2];
        
        filterFrm filterfrm = null;  //filter form to filter data. 
        helpFrm helpfrm = null; //help form to view help desc.
        searchFrm searchfrm = null; //search form to view searching result.

        EventWaitHandle myHandle = new EventWaitHandle(false, EventResetMode.ManualReset);  //将信号状态置为非终止，使用手动重置

        private void mainFrm_Load(object sender, EventArgs e)
        {
            
        }

        //start to perform async action
        private void BeginDealDataInformation(ListView listview,string fileName,EnumX enums)
        {
            

            DealDataInformationDelegateAsync dAsync = new DealDataInformationDelegateAsync(DealDataInformation);
            IAsyncResult iar = dAsync.BeginInvoke(listview,fileName,enums,new AsyncCallback(EndDealDataInformation),dAsync);
            
            if ((enumThis = enums) == EnumX.leftSide) tsStatus.Text = "正在加载左边文件的数据，请等待...";
            if ((enumThis = enums) == EnumX.rightSide) tsStatus.Text = "正在加载右边文件的数据，请等待...";

            
        }

        //returen the async running result
        private void EndDealDataInformation(IAsyncResult iar)
        {
            
            UIThread.UIInvoke(this.toolStrip1, delegate
            {
                if (enumThis == EnumX.leftSide) tsStatus.Text = "左边数据加载完毕，请继续下面操作...";
                if (enumThis == EnumX.rightSide) tsStatus.Text = "右边数据加载完毕，请继续下面操作...";
            });
            DealDataInformationDelegateAsync dAsync = (DealDataInformationDelegateAsync)iar.AsyncState;
            dAsync.EndInvoke(iar);
        }


        //this is a function that takes a lot of time to run, need to use async action to perform it.
        private void DealDataInformation(ListView listview,string fileName,EnumX enums)
        {
            myHandle.Reset();//让其他需要等待的线程阻塞
            UIThread.UIInvoke(listview, delegate
            {
                listview.Columns.Clear();
                listview.Items.Clear();
            });

            if (ColumnHeaderCollection == null)
            {
                MessageBox.Show("文件内容为空或者不以逗号分隔！！！", "提示", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            int columnCount = ColumnHeaderCollection.Length;
            for (int i = 0; i < columnCount; i++)
            {
                ColumnHeader header = new ColumnHeader();
                header.Text = ColumnHeaderCollection[i];
                header.TextAlign = HorizontalAlignment.Left;

                UIThread.UIInvoke(listview, delegate {
                    listview.Columns.Add(header);               
                });
            }

            int tryResult;

            using (StreamReader sr = new StreamReader(fileName, Encoding.Default))
            {
                EmptyDataCache(enums);//empty dataCache collection
                
                string result;
                while ((result = sr.ReadLine()) != null)
                {
                    string[] _result = result.Split(',');
                    ListViewItem lvi = new ListViewItem(_result[0]);

                    if (Int32.TryParse(_result[0], out tryResult))
                    {
                        if (enums == EnumX.leftSide) DataCache.cacheRecordListOne.Add(Int32.Parse(_result[0]));  //cache the record
                        if (enums == EnumX.rightSide) DataCache.cacheRecordListTwo.Add(Int32.Parse(_result[0]));  //cache the record
                    }

                    for (int j = 1; j < _result.Length; j++)
                    {
                        lvi.SubItems.Add(_result[j]);
                    }

                    //add items
                    UIThread.UIInvoke(listview, delegate
                    {
                        listview.Items.Add(lvi);
                        if (enums == EnumX.leftSide)  DataCache.listItemLeft.Add(lvi);
                        if (enums == EnumX.rightSide) DataCache.listItemRight.Add(lvi);
                    });
                }
            }

            //remove the first item(commonly, it's a header)
            UIThread.UIInvoke(listview, delegate
            {
                listview.Items.RemoveAt(0);
                //DataCache.listItemLeft.RemoveAt(0);
                //DataCache.listItemRight.RemoveAt(0);
            });
            AddRowNum(listview);
            myHandle.Set();  //允许其他等待的线程运行
        }

        private void AddRowNum(ListView listview)
        {
            UIThread.UIInvoke(toolStrip1, delegate
            {
                tsStatus.Text = "正在计算行号，请等待...";
                arrawLeft.Enabled = false;
                arrawRight.Enabled = false;
            });

            ColumnHeader header = new ColumnHeader();
            header.Text = "RowNumber";
            header.TextAlign = HorizontalAlignment.Left;

            UIThread.UIInvoke(listview, delegate
            {
                listview.Columns.Insert(0, header);
            });
            for (int i = 1; i <= listview.Items.Count; i++)
            {
                UIThread.UIInvoke(listView1, delegate
                {
                    ListViewItem.ListViewSubItem lvsi = new ListViewItem.ListViewSubItem(listview.Items[i - 1], i.ToString());
                    listview.Items[i - 1].SubItems.Insert(0, lvsi);
                    if (i % 1000 == 0)
                    {
                        UIThread.UIInvoke(toolStrip1, delegate
                        {
                            tsStatus.Text = "正在计算行号，已经计算" + i + "行...";
                        });
                        listView1.Invalidate();
                    }
                });
            }

            UIThread.UIInvoke(toolStrip1, delegate
            {
                tsStatus.Text = "行号计算完毕...";
                arrawLeft.Enabled = true;
                arrawRight.Enabled = true;
            });
            listView1.Invalidate();
        }

        private void EmptyDataCache(EnumX enums)
        {
            if (enums == EnumX.leftSide)
            {
                DataCache.cacheRecordListOne.Clear();  //empty the list collection
                DataCache.listItemLeft.Clear();
            }
            if (enums == EnumX.rightSide)
            {
                DataCache.cacheRecordListTwo.Clear(); //empty the list collection
                DataCache.listItemRight.Clear();
            }
        }

        //get column header and add to listview
        private string[] GetColumnHeader(string fileName)
        {
            using (StreamReader sr = new StreamReader(fileName, Encoding.Default))
            {
                string result = sr.ReadLine();
                if (!String.IsNullOrEmpty(result))
                {
                    string[] _result = result.Split(',');
                    if (_result.Length != 0)
                    {
                        return _result;
                    }
                }
            }
            return null;
        }

        //open file action
        private void LoadFileAndAction(ref string fileName, ListView listview,EnumX enums)
        {
            OpenFileDialog openFileOne = new OpenFileDialog();
            openFileOne.Filter = "csv文件(*.csv)|*.csv|txt文件(*.txt)|*.txt|所有文件(*.*)|*.*";
            if (openFileOne.ShowDialog() == DialogResult.OK)
            {
                fileName = openFileOne.FileName;
                ColumnHeaderCollection = GetColumnHeader(fileName);
                BeginDealDataInformation(listview, fileName,enums);
            }
        }

        //open file on left side 
        private void fileLeft_Click(object sender, EventArgs e)
        {
            string fileName = string.Empty;
            LoadFileAndAction(ref fileName,listView1,EnumX.leftSide);
            GetFileName.FileNameOne = fileName;
        }

        //open file on right side 
        private void fileRight_Click(object sender, EventArgs e)
        {
            string fileName = string.Empty;
            LoadFileAndAction(ref fileName,listView2,EnumX.rightSide);
            GetFileName.FileNameTwo = fileName;
        }

        // the records in left is exist in right
        private void arrawLeft_Click(object sender, EventArgs e)
        {
            BeginColorTheResultAsync(EnumX.rightSide, listView2);
        }

        private void helpMe_Click(object sender, EventArgs e)
        {
            if (helpfrm == null || helpfrm.IsDisposed == true)
            {
                helpfrm = new helpFrm();
            }
            helpfrm.Show();
        }

        private void arrawRight_Click(object sender, EventArgs e)
        {
            BeginColorTheResultAsync(EnumX.leftSide, listView1);
        }



        private void ColorTheResultAsync(EnumX enums,ListView listview)
        {
            myHandle.WaitOne(); //处于等待状态，直到收到Set的信号
            CommonUntil commonUntil = new CommonUntil();
            List<int> existList=null;
            List<int> nonExistList = null;

            if (enums == EnumX.leftSide)
            {
                 existList = commonUntil.ReturnComparisonResult(DataCache.cacheRecordListOne, DataCache.cacheRecordListTwo)[0];
                 nonExistList=commonUntil.ReturnComparisonResult(DataCache.cacheRecordListOne, DataCache.cacheRecordListTwo)[1];

                listPartOne[0] = existList;
                listPartOne[1] = nonExistList;
            }

            if (enums == EnumX.rightSide)
            {

                existList = commonUntil.ReturnComparisonResult(DataCache.cacheRecordListTwo, DataCache.cacheRecordListOne)[0];
                nonExistList = commonUntil.ReturnComparisonResult(DataCache.cacheRecordListTwo, DataCache.cacheRecordListOne)[1];

                listPartTwo[0] = existList;
                listPartTwo[1] = nonExistList;
            }
            
            int __result;
            UIThread.UIInvoke(listview, delegate
            {
                
                foreach (ListViewItem lvi in listview.Items)
                {

                    if (Int32.TryParse(lvi.SubItems[1].Text, out __result))
                    {
                        if (existList.Contains(Int32.Parse(lvi.SubItems[1].Text)))
                        {
                            if (enums == EnumX.leftSide) lvi.BackColor = Color.Wheat;
                            if (enums == EnumX.rightSide) lvi.BackColor = Color.YellowGreen;
                        }
                    }
                }
                listview.Invalidate();
            });
        }



        private void BeginColorTheResultAsync(EnumX enums,ListView listview)
        {
            ColorTheResultDelegateAsync colorTheResultAsync = new ColorTheResultDelegateAsync(ColorTheResultAsync);
            IAsyncResult iar = colorTheResultAsync.BeginInvoke(enums, listview, new AsyncCallback(EndColorTheResultAsync),colorTheResultAsync);

            tsStatus.Text = "正在着色中，请等待...";
        }

        private void EndColorTheResultAsync(IAsyncResult iar)
        {
            tsStatus.Text = "着色完毕，请检测...";
            ColorTheResultDelegateAsync colorTheResultAsync = (ColorTheResultDelegateAsync)iar.AsyncState;
            colorTheResultAsync.EndInvoke(iar);
        }

        private void filterOrder_Click(object sender, EventArgs e)
        {
            if (listPartOne == null | listPartTwo == null) throw new Exception("集合为空...");

            if (filterfrm == null || filterfrm.IsDisposed == true)
            {
                filterfrm = new filterFrm(listPartOne, listPartTwo);
            }

            filterfrm.commonEventHandler+=new CommonDelegate(filterfrm_commonEventHandler);
            filterfrm.Show();
        }

        private void SortAction(List<int> list,ListView listview,List<ListViewItem> listItem)
        {
            listview.Items.Clear();
            int myResult;
            try
            {
                foreach (ListViewItem lviChild in listItem)
                {
                    if (Int32.TryParse(lviChild.SubItems[1].Text, out myResult))
                    {
                        if (list.Contains(Int32.Parse(lviChild.SubItems[1].Text)))
                        {
                            listview.Items.Add(lviChild.Clone() as ListViewItem);
                            //lvcTwoLeft.Add(lviChild.Clone() as ListViewItem);
                        }
                    }
                }
            }
            catch { MessageBox.Show("请着色后，再进行过滤操作！！", "提示", MessageBoxButtons.OK, MessageBoxIcon.Error); return; }
        }

        private void filterfrm_commonEventHandler(EnumX enumx,EnumSort enums)
        {
            switch(enumx)
            {
                case EnumX.leftSide:
                    
                    listView1.Items.Clear();
                    PerformLeftAndRightAction(EnumX.leftSide, enums, listPartOne, listView1, DataCache.listItemLeft, GetFileName.FileNameOne);
                    break;
                case EnumX.rightSide:
                    
                    listView2.Items.Clear();
                    PerformLeftAndRightAction(EnumX.rightSide, enums, listPartTwo, listView2, DataCache.listItemRight, GetFileName.FileNameTwo);
                    break;
                default:break;
            }
        }

        private void PerformLeftAndRightAction(EnumX enumx,EnumSort enums,List<int>[] list,ListView listview,List<ListViewItem> listitem,string fileName)
        {
            switch (enums)
            {
                case EnumSort.DiffOnly:
                    SortAction(list[1], listview, listitem);
                    break;
                case EnumSort.NonOnly:
                    SortAction(list[0], listview, listitem);
                    break;
                case EnumSort.Both:

                    break;

                case EnumSort.Cancel:
                    BeginDealDataInformation(listview, fileName, enumx);
                    BeginColorTheResultAsync(enumx, listview);
                    break;
                default: break;
            }
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            if (searchfrm == null || searchfrm.IsDisposed == true)
            {
                searchfrm = new searchFrm();
                searchfrm.ReturnResultEvent += new ReturenResultDelegate(searchfrm_ReturnResultEvent);
            }
            searchfrm.Show();
        }

        private void searchfrm_ReturnResultEvent(long record,EnumX enums)
        {
            switch (enums)
            {
                case EnumX.leftSide:
                    ColoredTheSearchItems(listView1,record);
                    break;
                case EnumX.rightSide:
                    ColoredTheSearchItems(listView2, record);
                    break;

                case EnumX.both:
                    ColoredTheSearchItems(listView1, record);
                    ColoredTheSearchItems(listView2, record);
                    break;
                default: break;
            }
        }

        private void ColoredTheSearchItems(ListView listview,long record)
        {
            listview.BeginUpdate();
            //ListViewItem listitem = listview.FindItemWithText(record.ToString(), true, 0);
            //ListViewItem[] collection = listview.Items.Find(record.ToString(), true);
            //foreach (ListViewItem lvi in collection)
            //{
            //    lvi.BackColor = Color.Blue;
            //    lvi.ForeColor = Color.White;
            //}

            foreach(ListViewItem lvi in listview.Items)
            {
                if (lvi.SubItems[1].Text.Equals(record.ToString()))
                {
                    lvi.BackColor = Color.Blue;
                    lvi.ForeColor = Color.White;
                }
            }

            listview.EndUpdate();
        }

        private void exportAllToExcel_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDlg = new SaveFileDialog();
            saveFileDlg.Filter = "Excel文件(*.xls)|*.xls|所有文件(*.*)|*.*";
            if (saveFileDlg.ShowDialog() == DialogResult.OK)
            {
                Thread tLeftOne = new Thread(new ParameterizedThreadStart(ExportPartOneOfLeft));
                Thread tRightOne = new Thread(new ParameterizedThreadStart(ExportPartOneOfRight));
                tLeftOne.Start((object)saveFileDlg);
                tRightOne.Start((object)saveFileDlg);
                
                saveFileDlg.Dispose();
            }
        }

        private void ExportPartOneOfLeft(object _saveFileDlg)
        {
            SaveFileDialog saveFileDlg = _saveFileDlg as SaveFileDialog;
            myHandle.Reset();
            BeginExportDataToExcel(saveFileDlg, EnumX.leftSide, EnumExport.All, GetFileName.FileNameOne);
            myHandle.Set();
        }

        private void ExportPartOneOfRight(object _saveFileDlg)
        {
            SaveFileDialog saveFileDlg = _saveFileDlg as SaveFileDialog;
            myHandle.WaitOne();
            BeginExportDataToExcel(saveFileDlg, EnumX.rightSide, EnumExport.All, GetFileName.FileNameTwo);
        }

        private void exportSomeToExcel_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDlg = new SaveFileDialog();
            saveFileDlg.Filter = "Excel文件(*.xls)|*.xls|所有文件(*.*)|*.*";
            if (saveFileDlg.ShowDialog() == DialogResult.OK)
            {

                Thread tLeftOne = new Thread(new ParameterizedThreadStart(ExportPartTwoOfLeft));
                Thread tRightOne = new Thread(new ParameterizedThreadStart(ExportPartTwoOfRight));
                tLeftOne.Start((object)saveFileDlg);
                tRightOne.Start((object)saveFileDlg);
                
                saveFileDlg.Dispose();
            }
        }

        private void ExportPartTwoOfLeft(object _saveFileDlg)
        {
            SaveFileDialog saveFileDlg = _saveFileDlg as SaveFileDialog;
            myHandle.Reset();
            BeginExportDataToExcel(saveFileDlg, EnumX.leftSide, EnumExport.Diff, GetFileName.FileNameOne);
            myHandle.Set();
        }

        private void ExportPartTwoOfRight(object _saveFileDlg)
        {
            SaveFileDialog saveFileDlg = _saveFileDlg as SaveFileDialog;
            myHandle.WaitOne();
            BeginExportDataToExcel(saveFileDlg, EnumX.rightSide, EnumExport.Diff, GetFileName.FileNameTwo);
        }

        private void BeginExportDataToExcel(SaveFileDialog saveFileDlg,EnumX enumx,EnumExport export,string filename)
        {
            
            ExportDataToExcelDelegateAsync exportToExcelDelegate = new ExportDataToExcelDelegateAsync(ExportDataToExcel);
            IAsyncResult iar = exportToExcelDelegate.BeginInvoke(saveFileDlg, enumx, export, filename, new AsyncCallback(EndExportDataToExcel), exportToExcelDelegate);
            UIThread.UIInvoke(toolStrip1, delegate
            {
                tsStatus.Text = "正在导出中，请等待...";
            });
        }

        private void EndExportDataToExcel(IAsyncResult result)
        {
          
            ExportDataToExcelDelegateAsync exportToExcelDelegate = (ExportDataToExcelDelegateAsync)result.AsyncState;
            exportToExcelDelegate.EndInvoke(result);
        }

        private void ExportDataToExcel(SaveFileDialog saveFileDlg,EnumX enumx,EnumExport export,string filename)
        {
            //init a new object of listview, it is used to store temp data for exporting
            ListView listviewForData = new ListView();
            listviewForData.View = View.Details;

            //loading data & color them 
            if (export == EnumExport.All)
            {
                DealDataInformation(listviewForData, filename, enumx);
                ColorTheResultAsync(enumx, listviewForData);
            }
            if (export == EnumExport.Diff)
            {
                if(enumx==EnumX.leftSide)
                    PerformLeftAndRightAction(enumx, EnumSort.DiffOnly, listPartOne, listviewForData, DataCache.listItemLeft,filename);
                if(enumx==EnumX.rightSide)
                    PerformLeftAndRightAction(enumx, EnumSort.DiffOnly, listPartTwo, listviewForData, DataCache.listItemRight, filename);
            }

            //in excel format
            CommonUntil commonUntil = new CommonUntil();
            string myFileName = Path.GetFileNameWithoutExtension(saveFileDlg.FileName);
            StringBuilder sbResult = commonUntil.ExcelExport(listviewForData);


            //get the save path
            string newFileName = string.Empty;
            if (export == EnumExport.All) 
            {
                if (enumx == EnumX.leftSide) newFileName = commonUntil.ReturnNewFileName(saveFileDlg.FileName, myFileName) + "LeftALL.xls";
                if (enumx == EnumX.rightSide) newFileName = commonUntil.ReturnNewFileName(saveFileDlg.FileName, myFileName) + "RightALL.xls";
            }
            if (export == EnumExport.Diff)
            {
                if (enumx == EnumX.leftSide) newFileName = commonUntil.ReturnNewFileName(saveFileDlg.FileName, myFileName) + "LeftDIFF.xls";
                if (enumx == EnumX.rightSide) newFileName = commonUntil.ReturnNewFileName(saveFileDlg.FileName, myFileName) + "RightDIFF.xls";
            }

            //writing data into filestream
            byte[] mybyte = Encoding.Default.GetBytes(sbResult.ToString());
            FileStream fs = new FileStream(newFileName, FileMode.OpenOrCreate, FileAccess.ReadWrite);
            fs.Write(mybyte, 0, mybyte.Length);
            fs.Flush();
            fs.Close();

            //dispose the resource
            listviewForData.Items.Clear();
            listviewForData.Dispose();

            UIThread.UIInvoke(toolStrip1, delegate
            {
                tsStatus.Text = "导出完成....";
            });
        }

       

    }
}
