﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ImCompareAPP
{
    public delegate void ReturenResultDelegate(long record,EnumX enums);
    public partial class searchFrm : Form
    {
        public searchFrm()
        {
            InitializeComponent();
        }

        private List<int> total = new List<int>();

        private EnumX enumx;

        public event ReturenResultDelegate ReturnResultEvent;

        private void btnSearch_Click(object sender, EventArgs e)
        {
            if (DoValidation(this.txtValue.Text))
            {
                long record = Int64.Parse(this.txtValue.Text);
                ReturnResultEvent(record,enumx);
            }
        }

        private bool DoValidation(string value)
        {
            long result;
            if (Int64.TryParse(value.Trim(), out result))
            {
                return true;
            }
            return false;
        }


        private void txtValue_TextChanged(object sender, EventArgs e)
        {
            long result;
            
            panContainer.Controls.Clear();
            string inputValue = txtValue.Text.Trim();
            if (!String.IsNullOrEmpty(inputValue))
            {
                bool flag = Int64.TryParse(inputValue, out result);
                if (flag)
                {
                    if (enumx == EnumX.leftSide)
                    {
                        AddSuggest(DataCache.cacheRecordListOne,inputValue,1);
                    }
                    else if (enumx == EnumX.rightSide)
                    {
                        AddSuggest(DataCache.cacheRecordListTwo, inputValue,2);
                    }
                    else if (enumx == EnumX.both)
                    {
                        AddSuggest(total, inputValue,0);
                    }

                }
                else
                {
                    MessageBox.Show("请输入数字,并确保不超出范围！！！", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);

                    return;
                }
            }
            else
            {
                panContainer.Visible = false;
            }
        }

        private void AddSuggest(List<int> list,string inputValue,int flag)
        {
            var mySearchValue = (from p in list
                                             where p.ToString().StartsWith(inputValue)
                                             select p).Take(10);
                        List<int> l = mySearchValue.ToList<int>();
                        int count = 0;
                        AddToSuggestToUI(count, l,flag);
        }

        private void AddToSuggestToUI(int count,List<int> l,int flag)
        {
            panContainer.Visible = false;
            if (flag == 0)  //both
            {
                AddColorToResult(count,l,Color.Black);
            }
            if (flag == 1) //leftside
            {
                AddColorToResult(count,l,Color.Blue);
            }
            if (flag == 2) //rightside
            {
                AddColorToResult(count,l,Color.DarkGreen);
            }
            
        }

        private void AddColorToResult(int count, IList<int> l,Color color)
        {
            foreach (int i in l)
            {
                panContainer.Visible = true;
                Label label = new Label();
                label.Text = i.ToString();
                label.ForeColor = color;
                label.Click+=new EventHandler(label_Click);
                label.Parent = panContainer;
                panContainer.Controls.Add(label);
                count++;
                panContainer.Height = 12 * count;
            }
        }

        //perform the click event
        private void label_Click(object sender, EventArgs e)
        {
            
            Label l=sender as Label;
            panContainer.Visible = false;
            this.txtValue.Text = l.Text;
            
        }

        //搜索左边数据
        private void chbLeft_CheckedChanged(object sender, EventArgs e)
        {
            CheckState();
        }

        //搜索右边数据
        private void chbRight_CheckedChanged(object sender, EventArgs e)
        {
            CheckState();
        }

        private void CheckState()
        {
            if ((chbLeft.Checked && chbRight.Checked) || (!chbLeft.Checked) && (!chbRight.Checked))
            {
                enumx = EnumX.both;  //均选中
                total.AddRange(DataCache.cacheRecordListOne.ToList<int>());
                total.AddRange(DataCache.cacheRecordListTwo.ToList<int>());
            }
            if (chbLeft.Checked && !chbRight.Checked) enumx = EnumX.leftSide; //选中左边
            if (!chbLeft.Checked && chbRight.Checked) enumx = EnumX.rightSide; //选中右边

        }
    }
}
